Subject: bug#17997: md5sum adds a new line at the end of the input

From: [email-masked]
Date: Fri, 11 Jul 2014 10:48:30 +0200

Hello,

I implemented my own MD5 generator.
It provides the same results as all the online MD5 generators, like for instance http://onlinemd5.com/.

But it gives a different result than the GNU md5sum tool.
So I investigated this : it seems that md5sum adds a newline at the end of the input !

That is quite easy to test :
- go to http://onlinemd5.com/, type "test" as text input. The MD5 sum is 098f6bcd4621d373cade4e832627b4f6
- now type in a prompt : "echo test | md5sum". The MD5 sum is d8e8fca2dc0f896fd7cb4cb0031ba249
- back to onlinemd5.com, type "test" and press enter to add a new line in the input. Now the MD5 sum is d8e8fca2dc0f896fd7cb4cb0031ba249 !!

This behaviour was detected on RedHat Enterprise Linux 6.3 with GNU Coreutils 8.4.
I was able to reproduce it using the latest 8.22 version (fresh build) on the same machine, and on CentOS 5.10 with Coreutils 5.97.

Did someone know about this ?

Best regards,
Xavier Richez.